(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.Nymph = mod.exports;
  }
})(this, function (exports) {
  /* global XMLHttpRequest */
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  function _extendableBuiltin5(cls) {
    function ExtendableBuiltin() {
      var instance = Reflect.construct(cls, Array.from(arguments));
      Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
      return instance;
    }

    ExtendableBuiltin.prototype = Object.create(cls.prototype, {
      constructor: {
        value: cls,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });

    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(ExtendableBuiltin, cls);
    } else {
      ExtendableBuiltin.__proto__ = cls;
    }

    return ExtendableBuiltin;
  }

  function _extendableBuiltin3(cls) {
    function ExtendableBuiltin() {
      var instance = Reflect.construct(cls, Array.from(arguments));
      Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
      return instance;
    }

    ExtendableBuiltin.prototype = Object.create(cls.prototype, {
      constructor: {
        value: cls,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });

    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(ExtendableBuiltin, cls);
    } else {
      ExtendableBuiltin.__proto__ = cls;
    }

    return ExtendableBuiltin;
  }

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  function _extendableBuiltin(cls) {
    function ExtendableBuiltin() {
      var instance = Reflect.construct(cls, Array.from(arguments));
      Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
      return instance;
    }

    ExtendableBuiltin.prototype = Object.create(cls.prototype, {
      constructor: {
        value: cls,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });

    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(ExtendableBuiltin, cls);
    } else {
      ExtendableBuiltin.__proto__ = cls;
    }

    return ExtendableBuiltin;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  var sortProperty = null;
  var sortParent = null;
  var sortCaseSensitive = null;
  var xsrfToken = null;

  var isArray = Array.isArray || function (arr) {
    return Object.prototype.toString.call(arr) === '[object Array]';
  };

  var arraySortProperty = function arraySortProperty(a, b) {
    var aprop = void 0;
    var bprop = void 0;
    var property = sortProperty;
    var parent = sortParent;
    var notData = property === 'guid' || property === 'cdate' || property === 'mdate';
    if (parent != null && (a.data[parent] instanceof Nymph.getEntityClass('Nymph\\Entity') && typeof (notData ? a.data[parent][property] : a.data[parent].data[property]) !== 'undefined' || b.data[parent] instanceof Nymph.getEntityClass('Nymph\\Entity') && typeof (notData ? b.data[parent][property] : b.data[parent].data[property]) !== 'undefined')) {
      if (!sortCaseSensitive && typeof (notData ? a.data[parent][property] : a.data[parent].data[property]) === 'string' && typeof (notData ? b.data[parent][property] : b.data[parent].data[property]) === 'string') {
        aprop = (notData ? a.data[parent][property] : a.data[parent].data[property]).toUpperCase();
        bprop = (notData ? b.data[parent][property] : b.data[parent].data[property]).toUpperCase();
        if (aprop !== bprop) {
          return aprop.localeCompare(bprop);
        }
      } else {
        if ((notData ? a.data[parent][property] : a.data[parent].data[property]) > (notData ? b.data[parent][property] : b.data[parent].data[property])) {
          return 1;
        }
        if ((notData ? a.data[parent][property] : a.data[parent].data[property]) < (notData ? b.data[parent][property] : b.data[parent].data[property])) {
          return -1;
        }
      }
    }
    // If they have the same parent, order them by their own property.
    if (!sortCaseSensitive && typeof (notData ? a[property] : a.data[property]) === 'string' && typeof (notData ? b[property] : b.data[property]) === 'string') {
      aprop = (notData ? a[property] : a.data[property]).toUpperCase();
      bprop = (notData ? b[property] : b.data[property]).toUpperCase();
      return aprop.localeCompare(bprop);
    } else {
      if ((notData ? a[property] : a.data[property]) > (notData ? b[property] : b.data[property])) {
        return 1;
      }
      if ((notData ? a[property] : a.data[property]) < (notData ? b[property] : b.data[property])) {
        return -1;
      }
    }
    return 0;
  };

  var map = function map(arr, fn) {
    var results = [];
    for (var i = 0; i < arr.length; i++) {
      results.push(fn(arr[i], i));
    }
    return results;
  };

  var makeUrl = function makeUrl(url, data, noSep) {
    if (!data) {
      return url;
    }
    for (var k in data) {
      if (data.hasOwnProperty(k)) {
        if (noSep) {
          url = url + (url.length ? '&' : '');
        } else {
          url = url + (url.indexOf('?') !== -1 ? '&' : '?');
        }
        url = url + encodeURIComponent(k) + '=' + encodeURIComponent(data[k]);
      }
    }
    return url;
  };

  var filterPhpMessages = function filterPhpMessages(text) {
    var phpMessages = /<br \/>\n(<b>[\w ]+<\/b>:.*?)<br \/>\n/gm;
    if (text.match(phpMessages)) {
      var match = void 0;
      while ((match = phpMessages.exec(text)) !== null) {
        console.log('PHP Message:', match[1].replace(/<\/?b>/g, ''));
      }
      text = text.replace(phpMessages, '');
    }
    return text;
  };

  var onReadyStateChange = function onReadyStateChange(opt) {
    return function () {
      if (this.readyState === 4) {
        if (this.status >= 200 && this.status < 400) {
          var response = filterPhpMessages(this.responseText);
          if (opt.dataType === 'json') {
            if (!response.length) {
              throw new NymphInvalidResponseError('Server response was empty.');
            }
            try {
              opt.success(JSON.parse(response));
            } catch (e) {
              if (!(e instanceof SyntaxError)) {
                throw e;
              }
              throw new NymphInvalidResponseError('Server response was invalid.');
            }
          } else {
            opt.success(response);
          }
        } else {
          var errObj = void 0;
          try {
            errObj = JSON.parse(filterPhpMessages(this.responseText));
          } catch (e) {
            if (!(e instanceof SyntaxError)) {
              throw e;
            }
          }
          if ((typeof errObj === 'undefined' ? 'undefined' : _typeof(errObj)) !== 'object') {
            errObj = {
              textStatus: this.responseText
            };
          }
          errObj.status = this.status;
          opt.error(errObj);
        }
      }
    };
  };

  var getAjax = function getAjax(opt) {
    var request = new XMLHttpRequest();
    request.open('GET', makeUrl(opt.url, opt.data), true);

    request.onreadystatechange = onReadyStateChange(opt);

    if (xsrfToken !== null) {
      request.setRequestHeader('X-Xsrf-Token', xsrfToken);
    }
    request.send();
    request = null;
  };

  var postputdelAjax = function postputdelAjax(opt) {
    var request = new XMLHttpRequest();
    request.open(opt.type, opt.url, true);

    request.onreadystatechange = onReadyStateChange(opt);

    if (xsrfToken !== null) {
      request.setRequestHeader('X-Xsrf-Token', xsrfToken);
    }
    request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
    request.send(makeUrl('', opt.data, true));
    request = null;
  };

  var Nymph = exports.Nymph = function () {
    function Nymph() {
      _classCallCheck(this, Nymph);
    }

    _createClass(Nymph, null, [{
      key: 'setEntityClass',

      // === Static Methods ===

      value: function setEntityClass(className, entityClass) {
        Nymph.entityClasses[className] = entityClass;
      }
    }, {
      key: 'getEntityClass',
      value: function getEntityClass(className) {
        if (Nymph.entityClasses.hasOwnProperty(className)) {
          return Nymph.entityClasses[className];
        }
        if (typeof window !== 'undefined' && typeof window[className] !== 'undefined' && window[className] instanceof Nymph.entityClasses['Nymph\\Entity']) {
          return window[className];
        }
        return null;
      }
    }, {
      key: 'init',
      value: function init(NymphOptions) {
        this.restURL = NymphOptions.restURL;
      }
    }, {
      key: 'newUID',
      value: function newUID(name) {
        var _this = this;

        return new Promise(function (resolve, reject) {
          postputdelAjax({
            type: 'POST',
            url: _this.restURL,
            dataType: 'text',
            data: { 'action': 'uid', 'data': name },
            success: function success(data) {
              resolve(Number(data));
            },
            error: function error(errObj) {
              reject(errObj);
            }
          });
        });
      }
    }, {
      key: 'setUID',
      value: function setUID(name, value) {
        var _this2 = this;

        return new Promise(function (resolve, reject) {
          postputdelAjax({
            type: 'PUT',
            url: _this2.restURL,
            dataType: 'json',
            data: { 'action': 'uid', 'data': JSON.stringify({ 'name': name, 'value': value }) },
            success: function success(data) {
              resolve(data);
            },
            error: function error(errObj) {
              reject(errObj);
            }
          });
        });
      }
    }, {
      key: 'getUID',
      value: function getUID(name) {
        var _this3 = this;

        return new Promise(function (resolve, reject) {
          getAjax({
            url: _this3.restURL,
            dataType: 'text',
            data: { 'action': 'uid', 'data': name },
            success: function success(data) {
              resolve(Number(data));
            },
            error: function error(errObj) {
              reject(errObj);
            }
          });
        });
      }
    }, {
      key: 'deleteUID',
      value: function deleteUID(name) {
        var _this4 = this;

        return new Promise(function (resolve, reject) {
          postputdelAjax({
            type: 'DELETE',
            url: _this4.restURL,
            data: { 'action': 'uid', 'data': name },
            success: function success(data) {
              resolve(data);
            },
            error: function error(errObj) {
              reject(errObj);
            }
          });
        });
      }
    }, {
      key: 'saveEntity',
      value: function saveEntity(entity, plural) {
        var _this5 = this;

        var method = void 0;
        if (plural) {
          entity.forEach(function (cur) {
            if (!method) {
              method = cur.guid === null ? 'POST' : 'PUT';
            } else if (method === 'POST' && cur.guid !== null || method === 'PUT' && cur.guid === null) {
              throw new NymphInvalidRequestError('Due to REST restriction, you can only create new entities or update existing entities, not both at the same time.');
            }
          });
          if (!method) {
            method = 'POST';
          }
        } else {
          method = entity.guid === null ? 'POST' : 'PUT';
        }
        return new Promise(function (resolve, reject) {
          postputdelAjax({
            type: method,
            url: _this5.restURL,
            dataType: 'json',
            data: { 'action': plural ? 'entities' : 'entity', 'data': JSON.stringify(entity) },
            success: function success(data) {
              if (plural && entity.length === data.length) {
                for (var i = 0; i < data.length; i++) {
                  if (typeof data[i].guid !== 'undefined' && data[i].guid > 0 && (entity[i].guid === null || entity[i].guid === data[i].guid)) {
                    entity[i].init(data[i]);
                  }
                }
                resolve(entity);
              } else if (typeof data.guid !== 'undefined' && data.guid > 0) {
                resolve(entity.init(data));
              } else {
                reject({ textStatus: 'Server error' }); // eslint-disable-line prefer-promise-reject-errors
              }
            },
            error: function error(errObj) {
              reject(errObj);
            }
          });
        });
      }
    }, {
      key: 'saveEntities',
      value: function saveEntities(entities) {
        return this.saveEntity(entities, true);
      }
    }, {
      key: 'getEntity',
      value: function getEntity(options) {
        var _this6 = this;

        for (var _len = arguments.length, selectors = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          selectors[_key - 1] = arguments[_key];
        }

        return new Promise(function (resolve, reject) {
          _this6.getEntityData.apply(_this6, [options].concat(selectors)).then(function (data) {
            if (data !== null) {
              if (options.return && options.return === 'guid') {
                resolve(data);
              } else {
                resolve(_this6.initEntity(data));
              }
            } else {
              resolve(null);
            }
          }, function (errObj) {
            reject(errObj);
          });
        });
      }
    }, {
      key: 'getEntityData',
      value: function getEntityData(options) {
        var _this7 = this;

        for (var _len2 = arguments.length, selectors = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          selectors[_key2 - 1] = arguments[_key2];
        }

        return new Promise(function (resolve, reject) {
          getAjax({
            url: _this7.restURL,
            dataType: 'json',
            data: { 'action': 'entity', 'data': JSON.stringify([options].concat(selectors)) },
            success: function success(data) {
              if (typeof data.guid !== 'undefined' && data.guid > 0) {
                resolve(data);
              } else {
                resolve(null);
              }
            },
            error: function error(errObj) {
              reject(errObj);
            }
          });
        });
      }
    }, {
      key: 'getEntities',
      value: function getEntities(options) {
        var _this8 = this;

        for (var _len3 = arguments.length, selectors = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
          selectors[_key3 - 1] = arguments[_key3];
        }

        return new Promise(function (resolve, reject) {
          getAjax({
            url: _this8.restURL,
            dataType: 'json',
            data: { 'action': 'entities', 'data': JSON.stringify([options].concat(selectors)) },
            success: function success(data) {
              if (options.return && options.return === 'guid') {
                resolve(data);
              } else {
                resolve(map(data, _this8.initEntity.bind(_this8)));
              }
            },
            error: function error(errObj) {
              reject(errObj);
            }
          });
        });
      }
    }, {
      key: 'initEntity',
      value: function initEntity(entityJSON) {
        var EntityClass = Nymph.getEntityClass(entityJSON.class);
        if (!EntityClass) {
          throw new NymphClassNotAvailableError(entityJSON.class + ' class cannot be found.');
        }
        var entity = new EntityClass();
        return entity.init(entityJSON);
      }
    }, {
      key: 'initEntitiesFromData',
      value: function initEntitiesFromData(item) {
        if (isArray(item)) {
          // Recurse into lower arrays.
          return map(item, this.initEntitiesFromData.bind(this));
        } else if (item instanceof Object && !(item instanceof this.getEntityClass('Nymph\\Entity'))) {
          if (item.hasOwnProperty('class') && Nymph.getEntityClass(item.class) && item.hasOwnProperty('guid') && item.hasOwnProperty('cdate') && item.hasOwnProperty('mdate') && item.hasOwnProperty('tags') && item.hasOwnProperty('data')) {
            return this.initEntity(item);
          } else {
            for (var k in item) {
              if (item.hasOwnProperty(k)) {
                item[k] = this.initEntitiesFromData(item[k]);
              }
            }
          }
        }
        // Not an entity or array, just return it.
        return item;
      }
    }, {
      key: 'deleteEntity',
      value: function deleteEntity(entity, plural) {
        var _this9 = this;

        var jsonData = void 0,
            cur = void 0;
        if (plural) {
          jsonData = [];
          for (var i = 0; i < entity.length; i++) {
            cur = entity[i].toJSON();
            jsonData.push(cur);
          }
        } else {
          jsonData = entity.toJSON();
        }
        return new Promise(function (resolve, reject) {
          postputdelAjax({
            type: 'DELETE',
            url: _this9.restURL,
            dataType: 'json',
            data: { 'action': plural ? 'entities' : 'entity', 'data': JSON.stringify(jsonData) },
            success: function success(data) {
              resolve(data);
            },
            error: function error(errObj) {
              reject(errObj);
            }
          });
        });
      }
    }, {
      key: 'deleteEntities',
      value: function deleteEntities(entities) {
        return this.deleteEntity(entities, true);
      }
    }, {
      key: 'serverCall',
      value: function serverCall(entity, method, params) {
        var _this10 = this;

        return new Promise(function (resolve, reject) {
          postputdelAjax({
            type: 'POST',
            url: _this10.restURL,
            dataType: 'json',
            data: { 'action': 'method', 'data': JSON.stringify({ 'entity': entity, 'method': method, 'params': params }) },
            success: function success(data) {
              resolve(_this10.initEntitiesFromData(data));
            },
            error: function error(errObj) {
              reject(errObj);
            }
          });
        });
      }
    }, {
      key: 'serverCallStatic',
      value: function serverCallStatic(className, method, params) {
        var _this11 = this;

        return new Promise(function (resolve, reject) {
          postputdelAjax({
            type: 'POST',
            url: _this11.restURL,
            dataType: 'json',
            data: { 'action': 'method', 'data': JSON.stringify({ 'class': className, 'static': true, 'method': method, 'params': params }) },
            success: function success(data) {
              resolve(_this11.initEntitiesFromData(data));
            },
            error: function error(errObj) {
              reject(errObj);
            }
          });
        });
      }
    }, {
      key: 'hsort',
      value: function hsort(array, property, parentProperty, caseSensitive, reverse) {
        // First sort by the requested property.
        this.sort(array, property, caseSensitive, reverse);
        if (typeof parentProperty === 'undefined' || parentProperty === null) {
          return array;
        }

        // Now sort by children.
        var newArray = [];
        // Look for entities ready to go in order.
        var changed = void 0,
            pkey = void 0,
            ancestry = void 0,
            newKey = void 0;
        while (array.length) {
          changed = false;
          for (var key = 0; key < array.length; key++) {
            // Must break after adding one, so any following children don't go in the wrong order.
            if (typeof array[key].data[parentProperty] === 'undefined' || array[key].data[parentProperty] === null || typeof array[key].data[parentProperty].inArray !== 'function' || !array[key].data[parentProperty].inArray(newArray.concat(array))) {
              // If they have no parent (or their parent isn't in the array), they go on the end.
              newArray.push(array[key]);
              array.splice(key, 1);
              changed = true;
              break;
            } else {
              // Else find the parent.
              pkey = array[key].data[parentProperty].arraySearch(newArray);
              if (pkey !== false) {
                // And insert after the parent.
                // This makes entities go to the end of the child list.
                ancestry = [array[key].data[parentProperty].guid];
                newKey = Number(pkey);
                while (typeof newArray[newKey + 1] !== 'undefined' && typeof newArray[newKey + 1].data[parentProperty] !== 'undefined' && newArray[newKey + 1].data[parentProperty] !== null && ancestry.indexOf(newArray[newKey + 1].data[parentProperty].guid) !== -1) {
                  ancestry.push(newArray[newKey + 1].guid);
                  newKey += 1;
                }
                // Where to place the entity.
                newKey += 1;
                if (typeof newArray[newKey] !== 'undefined') {
                  // If it already exists, we have to splice it in.
                  newArray.splice(newKey, 0, array[key]);
                } else {
                  // Else just add it.
                  newArray.push(array[key]);
                }
                array.splice(key, 1);
                changed = true;
                break;
              }
            }
          }
          if (!changed) {
            // If there are any unexpected errors and the array isn't changed, just stick the rest on the end.
            if (array.length) {
              newArray = newArray.concat(array);
              array = [];
            }
          }
        }
        // Now push the new array out.
        array = newArray;
        return array;
      }
    }, {
      key: 'psort',
      value: function psort(array, property, parentProperty, caseSensitive, reverse) {
        // Sort by the requested property.
        if (typeof property !== 'undefined') {
          sortProperty = property;
          sortParent = parentProperty;
          sortCaseSensitive = !!caseSensitive;
          array.sort(arraySortProperty);
        }
        if (reverse) {
          array.reverse();
        }
        return array;
      }
    }, {
      key: 'sort',
      value: function sort(array, property, caseSensitive, reverse) {
        // Sort by the requested property.
        if (typeof property !== 'undefined') {
          sortProperty = property;
          sortParent = null;
          sortCaseSensitive = !!caseSensitive;
          array.sort(arraySortProperty);
        }
        if (reverse) {
          array.reverse();
        }
        return array;
      }
    }, {
      key: 'setXsrfToken',
      value: function setXsrfToken(token) {
        xsrfToken = token;
      }
    }]);

    return Nymph;
  }();

  // === Static Properties ===

  // The current version of Nymph Client.
  Nymph.version = '4.0.0-beta.11';
  Nymph.entityClasses = {};

  // === Error Classes ===

  var NymphClassNotAvailableError = exports.NymphClassNotAvailableError = function (_extendableBuiltin2) {
    _inherits(NymphClassNotAvailableError, _extendableBuiltin2);

    function NymphClassNotAvailableError(message) {
      _classCallCheck(this, NymphClassNotAvailableError);

      var _this12 = _possibleConstructorReturn(this, (NymphClassNotAvailableError.__proto__ || Object.getPrototypeOf(NymphClassNotAvailableError)).call(this, message));

      _this12.name = 'NymphClassNotAvailableError';
      return _this12;
    }

    return NymphClassNotAvailableError;
  }(_extendableBuiltin(Error));

  var NymphInvalidRequestError = exports.NymphInvalidRequestError = function (_extendableBuiltin4) {
    _inherits(NymphInvalidRequestError, _extendableBuiltin4);

    function NymphInvalidRequestError(message) {
      _classCallCheck(this, NymphInvalidRequestError);

      var _this13 = _possibleConstructorReturn(this, (NymphInvalidRequestError.__proto__ || Object.getPrototypeOf(NymphInvalidRequestError)).call(this, message));

      _this13.name = 'NymphInvalidRequestError';
      return _this13;
    }

    return NymphInvalidRequestError;
  }(_extendableBuiltin3(Error));

  var NymphInvalidResponseError = exports.NymphInvalidResponseError = function (_extendableBuiltin6) {
    _inherits(NymphInvalidResponseError, _extendableBuiltin6);

    function NymphInvalidResponseError(message) {
      _classCallCheck(this, NymphInvalidResponseError);

      var _this14 = _possibleConstructorReturn(this, (NymphInvalidResponseError.__proto__ || Object.getPrototypeOf(NymphInvalidResponseError)).call(this, message));

      _this14.name = 'NymphInvalidResponseError';
      return _this14;
    }

    return NymphInvalidResponseError;
  }(_extendableBuiltin5(Error));

  if (typeof window !== 'undefined' && typeof window.NymphOptions !== 'undefined') {
    Nymph.init(window.NymphOptions);
  }

  exports.default = Nymph;
});