(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', './Nymph', './PubSub', './Entity'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('./Nymph'), require('./PubSub'), require('./Entity'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Nymph, global.PubSub, global.Entity);
    global.NymphClient = mod.exports;
  }
})(this, function (exports, _Nymph, _PubSub, _Entity) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.EntityIsSleepingReferenceError = exports.Entity = exports.PubSubSubscription = exports.PubSub = exports.NymphInvalidResponseError = exports.NymphInvalidRequestError = exports.NymphClassNotAvailableError = exports.Nymph = undefined;
  exports.Nymph = _Nymph.Nymph;
  exports.NymphClassNotAvailableError = _Nymph.NymphClassNotAvailableError;
  exports.NymphInvalidRequestError = _Nymph.NymphInvalidRequestError;
  exports.NymphInvalidResponseError = _Nymph.NymphInvalidResponseError;
  exports.PubSub = _PubSub.PubSub;
  exports.PubSubSubscription = _PubSub.PubSubSubscription;
  exports.Entity = _Entity.Entity;
  exports.EntityIsSleepingReferenceError = _Entity.EntityIsSleepingReferenceError;
});